searchNodes=[{"doc":"Simple abstraction over the swedish BankID API.","ref":"ExBankID.html","title":"ExBankID","type":"module"},{"doc":"See ExBankID.Auth.auth/2.","ref":"ExBankID.html#auth/2","title":"ExBankID.auth/2","type":"function"},{"doc":"See ExBankID.Cancel.cancel/2.","ref":"ExBankID.html#cancel/2","title":"ExBankID.cancel/2","type":"function"},{"doc":"See ExBankID.Collect.collect/2.","ref":"ExBankID.html#collect/2","title":"ExBankID.collect/2","type":"function"},{"doc":"See ExBankID.Sign.sign/3.","ref":"ExBankID.html#sign/3","title":"ExBankID.sign/3","type":"function"},{"doc":"","ref":"ExBankID.Auth.html","title":"ExBankID.Auth","type":"module"},{"doc":"","ref":"ExBankID.Auth.html#auth/2","title":"ExBankID.Auth.auth/2","type":"function"},{"doc":"Provides the struct used when initiating a authentication","ref":"ExBankID.Auth.Payload.html","title":"ExBankID.Auth.Payload","type":"module"},{"doc":"Returns a Payload struct containing the given ip address and personal number.Examplesiex&gt; ExBankID.Auth.Payload.new(&quot;1.1.1.1&quot;) %ExBankID.Auth.Payload{endUserIp: &quot;1.1.1.1&quot;} iex&gt; ExBankID.Auth.Payload.new(&quot;qwerty&quot;) {:error, &quot;Invalid ip address: qwerty&quot;} iex&gt; ExBankID.Auth.Payload.new(&quot;1.1.1.1&quot;, [personal_number: &quot;190000000000&quot;]) %ExBankID.Auth.Payload{endUserIp: &quot;1.1.1.1&quot;, personalNumber: &quot;190000000000&quot;} iex&gt; ExBankID.Auth.Payload.new(&quot;1.1.1.1&quot;, [personal_number: &quot;Not a personal number&quot;]) {:error, &quot;Invalid personal number&quot;}","ref":"ExBankID.Auth.Payload.html#new/2","title":"ExBankID.Auth.Payload.new/2","type":"function"},{"doc":"","ref":"ExBankID.Auth.Payload.html#t:reason/0","title":"ExBankID.Auth.Payload.reason/0","type":"type"},{"doc":"Provides the struct used to represent the response from a successful request to the BankID /auth endpoint","ref":"ExBankID.Auth.Response.html","title":"ExBankID.Auth.Response","type":"module"},{"doc":"","ref":"ExBankID.Cancel.html","title":"ExBankID.Cancel","type":"module"},{"doc":"","ref":"ExBankID.Cancel.html#cancel/2","title":"ExBankID.Cancel.cancel/2","type":"function"},{"doc":"Provides the struct used when requesting to cancel a pending authentication or signing","ref":"ExBankID.Cancel.Payload.html","title":"ExBankID.Cancel.Payload","type":"module"},{"doc":"Returns a Cancel Payload given a orderRef, Auth response struct or Sign response structExamplesiex&gt; ExBankID.Cancel.Payload.new(&quot;131daac9-16c6-4618-beb0-365768f37288&quot;) %ExBankID.Cancel.Payload{orderRef: &quot;131daac9-16c6-4618-beb0-365768f37288&quot;} iex&gt; ExBankID.Cancel.Payload.new(&quot;Not-a-valid-UUID&quot;) {:error, &quot;OrderRef is not a valid UUID&quot;} iex&gt; %ExBankID.Auth.Response{orderRef: &quot;131daac9-16c6-4618-beb0-365768f37288&quot;} |&gt; ExBankID.Cancel.Payload.new() %ExBankID.Cancel.Payload{orderRef: &quot;131daac9-16c6-4618-beb0-365768f37288&quot;} iex&gt; %ExBankID.Sign.Response{orderRef: &quot;131daac9-16c6-4618-beb0-365768f37288&quot;} |&gt; ExBankID.Cancel.Payload.new() %ExBankID.Cancel.Payload{orderRef: &quot;131daac9-16c6-4618-beb0-365768f37288&quot;}","ref":"ExBankID.Cancel.Payload.html#new/1","title":"ExBankID.Cancel.Payload.new/1","type":"function"},{"doc":"","ref":"ExBankID.Collect.html","title":"ExBankID.Collect","type":"module"},{"doc":"","ref":"ExBankID.Collect.html#collect/2","title":"ExBankID.Collect.collect/2","type":"function"},{"doc":"","ref":"ExBankID.Collect.CompletionData.html","title":"ExBankID.Collect.CompletionData","type":"module"},{"doc":"","ref":"ExBankID.Collect.Payload.html","title":"ExBankID.Collect.Payload","type":"module"},{"doc":"","ref":"ExBankID.Collect.Payload.html#new/1","title":"ExBankID.Collect.Payload.new/1","type":"function"},{"doc":"","ref":"ExBankID.Collect.Response.html","title":"ExBankID.Collect.Response","type":"module"},{"doc":"","ref":"ExBankID.Collect.User.html","title":"ExBankID.Collect.User","type":"module"},{"doc":"Provides the struct use to represent a response from the BankID api that has http code 400 - 500.","ref":"ExBankID.Error.Api.html","title":"ExBankID.Error.Api","type":"module"},{"doc":"The expected behaviour an http clientYou can provide your own http client by creating a module that implements this behaviour. Things to consider:The HTTP method must be POST.cert_file will be the path to a pem file used to authenticate with the BankID API. Corresponds to certfileThe default implementation can be found in ExBankID.Http.Default","ref":"ExBankID.Http.Client.html","title":"ExBankID.Http.Client","type":"behaviour"},{"doc":"","ref":"ExBankID.Http.Client.html#c:post/5","title":"ExBankID.Http.Client.post/5","type":"callback"},{"doc":"HTTPoison implementation of the ExBankID.Http.Client behaviour.","ref":"ExBankID.Http.Default.html","title":"ExBankID.Http.Default","type":"module"},{"doc":"Callback implementation for ExBankID.Http.Client.post/5.","ref":"ExBankID.Http.Default.html#post/5","title":"ExBankID.Http.Default.post/5","type":"function"},{"doc":"","ref":"ExBankID.Http.Response.html","title":"ExBankID.Http.Response","type":"module"},{"doc":"","ref":"ExBankID.Http.Response.html#t:t/0","title":"ExBankID.Http.Response.t/0","type":"type"},{"doc":"","ref":"ExBankID.HttpRequest.html","title":"ExBankID.HttpRequest","type":"module"},{"doc":"","ref":"ExBankID.HttpRequest.html#send_request/2","title":"ExBankID.HttpRequest.send_request/2","type":"function"},{"doc":"","ref":"ExBankID.HttpRequest.html#t:opts/0","title":"ExBankID.HttpRequest.opts/0","type":"type"},{"doc":"","ref":"ExBankID.HttpRequest.html#t:payload/0","title":"ExBankID.HttpRequest.payload/0","type":"type"},{"doc":"","ref":"ExBankID.HttpRequest.html#t:response/0","title":"ExBankID.HttpRequest.response/0","type":"type"},{"doc":"","ref":"ExBankID.Sign.html","title":"ExBankID.Sign","type":"module"},{"doc":"","ref":"ExBankID.Sign.html#sign/3","title":"ExBankID.Sign.sign/3","type":"function"},{"doc":"Provides the struct used when initiating a signing of data","ref":"ExBankID.Sign.Payload.html","title":"ExBankID.Sign.Payload","type":"module"},{"doc":"Constructs a new Sign Payload with the given ip-address, user visible data, and optionally personal number and user non visible data. user_visible_data and user_non_visible_data will be properly encodeExamplesiex&gt; ExBankID.Sign.Payload.new(&quot;1.1.1.1&quot;, &quot;This will be visible in the bankID app&quot;) %ExBankID.Sign.Payload{endUserIp: &quot;1.1.1.1&quot;, userVisibleData: &quot;VGhpcyB3aWxsIGJlIHZpc2libGUgaW4gdGhlIGJhbmtJRCBhcHA=&quot;} iex&gt; ExBankID.Sign.Payload.new(&quot;1.1.1.1&quot;, &quot;This will be visible in the bankID app&quot;, personal_number: &quot;190000000000&quot;) %ExBankID.Sign.Payload{endUserIp: &quot;1.1.1.1&quot;, personalNumber: &quot;190000000000&quot;, userVisibleData: &quot;VGhpcyB3aWxsIGJlIHZpc2libGUgaW4gdGhlIGJhbmtJRCBhcHA=&quot;} iex&gt; ExBankID.Sign.Payload.new(&quot;Not a valid ip address&quot;, &quot;This will be visible in the bankID app&quot;, personal_number: &quot;190000000000&quot;) {:error, &quot;Invalid ip address Not a valid ip address&quot;}","ref":"ExBankID.Sign.Payload.html#new/3","title":"ExBankID.Sign.Payload.new/3","type":"function"},{"doc":"Provides the struct used to represent the response from a successful request to the BankID /sign endpoint","ref":"ExBankID.Sign.Response.html","title":"ExBankID.Sign.Response","type":"module"},{"doc":"exBankID","ref":"readme.html","title":"exBankID","type":"extras"},{"doc":"ExBankID is a simple stateless elixir client for the Swedish BankID API.","ref":"readme.html#introduction","title":"exBankID - Introduction","type":"extras"},{"doc":"This library is available as a package on hex.pm and can be installed by adding {:ex_bank_id, &quot;~&gt; 0.1.1&quot;, hex: :exBankID} to your list of dependencies in mix.exs","ref":"readme.html#installation","title":"exBankID - Installation","type":"extras"},{"doc":"# config/config.exs config :ex_bank_id, # Using a custom http client. Should be a module that implements ExBankID.Http.Client. # Defaults to ExBankID.Http.Default http_client: MyApp.Http.Client # The path to the client cert file used to authenticate with the BankID API # Defaults to the test cert in the assets directory. cert_file: &quot;/path/to/cert/file.pem&quot; # BankID API url # Defaults to &quot;https://appapi2.test.bankid.com/rp/v5.1/&quot; url: &quot;https://appapi2.bankid.com/rp/&lt;api version 5 or 5.1&gt;/&quot; All the above configuration options can be overridden by setting the new value for the corresponding key in the opts Keyword list passed to any of the functions in ExBankID.Example:# This will override the url in the config. ExBankID.auth(&quot;1.1.1.1&quot;, url: &quot;my.mock-server.local&quot;)","ref":"readme.html#configuration","title":"exBankID - Configuration","type":"extras"},{"doc":"# Authenticate with ip address and optionally the personal number (12 digits) iex&gt; {:ok, authentication} = ExBankID.auth(&quot;1.1.1.1&quot;, personal_number: &quot;190000000000&quot;) {:ok, %ExBankID.Auth.Response{ autoStartToken: &quot;3241031e-d849-4e3a-a662-1a36e65eff93&quot;, orderRef: &quot;9b69419c-b3ac-4f7c-9796-bf54f1a4e40b&quot;, qrStartSecret: &quot;c0846df5-f96d-49c0-9ef5-4126cd9376e9&quot;, qrStartToken: &quot;3fb97679-98cb-42da-afe6-62aecbaaab7e&quot; }} # Collect the status of the initiated authentication either with the orderRef # or with the ExBankID.Auth.Response struct iex&gt; {:ok, collect_response} = ExBankID.collect(&quot;9b69419c-b3ac-4f7c-9796-bf54f1a4e40b&quot;) {:ok, %ExBankID.Collect.Response{ completionData: %ExBankID.Collect.CompletionData{ cert: %{}, device: %{}, ocspResponse: nil, signature: nil, user: %ExBankID.Collect.User{ givenName: nil, name: nil, personalNumber: nil, surname: nil } }, hintCode: &quot;outstandingTransaction&quot;, orderRef: &quot;1fadf49f-c695-4bb3-869a-61aee9678009&quot;, status: &quot;pending&quot; }} # Using ExBankID.Auth.Response struct iex&gt; {:ok, collect_response} = ExBankID.collect(authentication) {:ok, %ExBankID.Collect.Response{ completionData: %ExBankID.Collect.CompletionData{ cert: %{}, device: %{}, ocspResponse: nil, signature: nil, user: %ExBankID.Collect.User{ givenName: nil, name: nil, personalNumber: nil, surname: nil } }, hintCode: &quot;outstandingTransaction&quot;, orderRef: &quot;1fadf49f-c695-4bb3-869a-61aee9678009&quot;, status: &quot;pending&quot; }} # When authentication is completed by the end user the fields in CompletionData will # be populated. #User signing a given message. iex&gt; {:ok, sign} = ExBankID.sign( &quot;1.1.1.1&quot;, &quot;This will be displayed in the BankID app&quot;, personal_number: &quot;190000000000&quot;, # Optional user_non_visible_data: &quot;Not displayed&quot; # Optional ) {:ok, %ExBankID.Sign.Response{ autoStartToken: &quot;c7b67410-c376-4d27-9aff-f7e331082619&quot;, orderRef: &quot;90b3816d-c1d3-4650-aa4d-26d9996160de&quot;, qrStartSecret: &quot;f28787ec-a554-4db4-90c6-dd662dd249bc&quot;, qrStartToken: &quot;c7a2373b-9a7a-470f-816f-0af0c3d82053&quot; }} # Collecting is done the same way as for a authentication. # Canceling a sign or authentication iex&gt; {:ok, _} = ExBankID.cancel(authentication) {:ok, %{}}","ref":"readme.html#basic-usage","title":"exBankID - Basic usage","type":"extras"}]